%global _default_patch_fuzz 2

%global selinuxtype targeted
%global moduletype services

Name:       onak
Version:    0.5.0
Release:    1%{?dist}
Summary:    onak - OpenPGP keyserver
Group:      Applications/Internet
License:    GPLv2+
URL:        http://www.earth.li/projectpurple/progs/onak.html
Source0:    http://www.earth.li/projectpurple/files/%{name}-%{version}.tar.xz
Source5:    onak.service
Source6:    onak.socket
Source7:    onak.logrotate
Source10:   onak.te
Source11:   onak.fc
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  coreutils glibc-devel gcc make libdb-devel libcurl-devel systemd
Requires: libdb-utils
Requires: logrotate
Requires(pre):  shadow-utils
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd

%description

onak is an OpenPGP keyserver. When I first started thinking about writing it there was no Free keyserver that could handle multiple subkey bindings. Now there are at least three I believe (CryptNet, onak and SKS). Also I wanted a keyserver that was integrated with my key pathfinder ( http://the.earth.li/~noodles/pathfind.html). onak does both of these. While there are many things it doesn't do at present that are on my todo list development is progressing. The pathfinder component works happily, it's possible to setup bidirectional key syncing with pksd via email and there are a variety of database backends available including plain files, PostgreSQL and Berkeley DB4.

%package selinux
Summary:          SELinux policy module supporting to query onak from apache
Group:            System Environment/Base
BuildRequires: selinux-policy-devel
Requires:         selinux-policy
Requires:         %{name} = %{version}-%{release}
Requires(post): selinux-policy-base
Requires(post): libselinux-utils
Requires(post): policycoreutils-python
%description selinux
SELinux policy module supporting to query onak from apache

%prep
%setup -q

mkdir selinux
%{__cp} -p %{SOURCE10} %{SOURCE11} selinux/

%build
%configure --prefix=/usr 
make %{?_smp_mflags}

cd selinux
make -f %{_datadir}/selinux/devel/Makefile
bzip2 -9 %{name}.pp

%install
make install DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_localstatedir}/lib/onak
mkdir -p %{buildroot}%{_localstatedir}/log/onak
mkdir -p %{buildroot}%{_libdir}/cgi-bin/pks
install -Dp -m0644 %{SOURCE5} %{buildroot}%{_unitdir}/onak.service
install -Dp -m0644 %{SOURCE6} %{buildroot}%{_unitdir}/onak.socket
install -Dp -m0644 %{SOURCE7} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}.conf
# fix log location
sed -i 's@^logfile=.*@logfile=/var/log/onak/onak.log@' onak.ini
# don't send mails by default
sed -i 's@^mta=@#mta=@' onak.ini
# fix socket loca
sed -i 's@^sock_dir=.*@sock_dir=/run/onak@' onak.ini
install -Dp -m0644 onak.ini %{buildroot}%{_sysconfdir}/onak.ini
install add lookup gpgwww %{buildroot}/%{_libdir}/cgi-bin/pks


cd selinux
install -d %{buildroot}%{_datadir}/selinux/packages
install -d -p %{buildroot}%{_datadir}/selinux/devel/include/services
install -p -m 644 %{name}.if %{buildroot}%{_datadir}/selinux/devel/include/services
install -m 0644 %{name}.pp.bz2 %{buildroot}%{_datadir}/selinux/packages

%clean
rm -rf %{buildroot}

%pre
# Add the "apache" group and user
/usr/sbin/groupadd -g 48 -r apache 2> /dev/null || :
/usr/sbin/useradd -c "Apache" -u 48 -g apache \
	-s /sbin/nologin -r -d /usr/share/httpd apache 2> /dev/null || :

%post

touch %{_localstatedir}/log/%{name}/%{name}.log && chown apache:apache %{_localstatedir}/log/%{name}/%{name}.log && chmod 0600 %{_localstatedir}/log/%{name}/%{name}.log
%systemd_post onak.service

%preun
%systemd_preun onak.service

%postun
%systemd_postun_with_restart onak.service

%post selinux
%{_sbindir}/semodule -n -s %{selinuxtype} -r %{name} 2> /dev/null
%{_sbindir}/semodule -n -X 200 -s %{selinuxtype} -i /usr/share/selinux/packages/%{name}.pp.bz2 > /dev/null

if %{_sbindir}/selinuxenabled ; then
  %{_sbindir}/load_policy
  if [ $1 -eq 1 ]; then
    /sbin/fixfiles -R %{name} restore || :
    /sbin/restorecon -R %{_libdir}/cgi-bin/pks %{_localstatedir}/lib/%{name} %{_localstatedir}/log/%{name} || :
  fi
fi


%postun selinux
if [ $1 -eq 0 ]; then
  if %{_sbindir}/selinuxenabled ; then
    %{_sbindir}/load_policy
  fi
fi

%files
%defattr(-,root,root,-)
%doc apache2 BUGS CGI HISTORY PERFORMANCE README THANKS TODO 
%license LICENSE
%attr(0755,root,root) %{_bindir}/onak
%attr(0755,root,root) %{_bindir}/splitkeys
%attr(0755,root,root) %{_bindir}/keydctl
%attr(0755,root,root) %{_sbindir}/keyd
%attr(0644,root,root) %{_mandir}/man*/onak*
%attr(0644,root,root) %{_mandir}/man8/keyd*
%attr(0644,root,root) %{_mandir}/man1/splitkeys*
%attr(0640,root,apache) %config(noreplace) %{_sysconfdir}/%{name}.ini
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}.conf
%attr(0770,apache,apache) %{_localstatedir}/lib/onak
%attr(0755,root,root) %{_libdir}/onak/onak-mail.pl
%attr(0644,root,root) %{_libdir}/onak/backends/*.so
%attr(0755,root,root) %{_libdir}/cgi-bin
%dir %attr(0700,apache,apache) %{_localstatedir}/log/%{name}
%{_unitdir}/%{name}.*

%files selinux
%defattr(-,root,root,-)
%{_datadir}/selinux/*

%changelog
* Tue Sep 26 2017 mh <mh+rpms@immerda.ch> - 0.5.0-1
- initial release

